<?php

declare(strict_types=1);

namespace Drupal\tailwindcss_utility;

final class ThemePreprocessor {

  /**
   * Adds Tailwind classes to sections and blocks basing on config.
   */
  public static function preprocessLayout(array &$variables, string $hook): void {
    // Section classes.
    if (\array_key_exists('settings', $variables) && \array_key_exists('tailwind_classes', $variables['settings'])) {
      $classes = \array_filter(\explode(' ', $variables['settings']['tailwind_classes']));
      foreach ($classes as $class) {
        $variables['attributes']['class'][] = \trim($class);
      }
    }

    // Content classes.
    if (\array_key_exists('content', $variables) && \array_key_exists('content', $variables['content'])) {
      $content = &$variables['content']['content'];
      foreach ($content as $key => $item) {
        if (
          \array_key_exists('#configuration', $item) &&
          \array_key_exists('settings', $item['#configuration']) &&
          \array_key_exists('tailwind_classes', $item['#configuration']['settings'])
        ) {
          $classes = \array_filter(\explode(' ', $item['#configuration']['settings']['tailwind_classes']));
          foreach ($classes as $class) {
            $content[$key]['#attributes']['class'][] = $class;
          }
        }
      }
    }
  }

}
